#ifndef __INCLUDE_ARCH_APIC_H
#define __INCLUDE_ARCH_APIC_H

#include <types.h>

#define IA32_APIC_BASE_MSR 0x1B
#define IA32_APIC_BASE_MSR_ENABLE 0x800

void amd64_apic_ipi(uint64 apic_base_addr, uint32 dest, uint32 type, uint8 vec);
void amd64_apic_write(uint64 apic_base_addr, uint32 offset, uint32 value);
uint32 amd64_apic_read(uint64 apic_base_addr, uint8 offset);

#endif /* __INCLUDE_ARCH_APIC_H */