#include <arch/amd64/vm.h>
#include <arch/amd64/types.h>

#include <types.h>
#include <alloc.h>

int get_no()
{
uint8 *vidmem = ((uint64)0xB8000 + KERNEL_PHYSICAL_AREA_START);

	return (int)vidmem[8];
}

#define TEST_SIZE 256
void page_alloc_test()
{
uint64 *p;
uint64 *pp;
	p = mm_page_alloc_cont(5);
	printk("p=%p\n",p);

	pp = p;
	mm_page_alloc();
	mm_page_free(p);

	//p = mm_page_alloc();
	p = mm_page_alloc();
	printk("pp=%p p=%p\n",pp,p);
}



int main(uint32 mboot_magic, uint32 mboot_info)
{
unsigned char *vidmem = (unsigned char *)KERNEL_VMA + 0xB8000;

asm("cli");
	amd64_gdt_init();
	amd64_idt_init();

	debugconsole_init();
	printk("\nfuze64: version 0.0.1, written by Ian Gilmour\n");
	
	amd64_paging_init();

	// Read mboot header
	amd64_mboot_init(mboot_info,mboot_magic);

	// Init page allocator
	mm_page_init(amd64_get_low_addr(),amd64_get_high_addr());


//	uint64 *better_stack = mm_page_alloc_cont(4);
//	__asm__ volatile ("movq %0, %%rsp" :: "r" (((uint64)better_stack + (4*PAGESIZE)-100)): "memory");
	
	kheap_alloc_init();
	amd64_mp_init();	
	
	//asm("int $3");
	uint64 *p = (uint64*)0xFFFFFFFFF;
	*p = 0L;
	printk("yo");

	//uint8 *p = (void*)mm_page_alloc();
	//p = (void*)mm_page_alloc();
	//for(;;);

	

	

	//kheap_show_stats();
	//amd64_mp_test_func();
	for(;;) vidmem[80]++;

}
