#include <types.h>
#include <spinlock.h>
#include <arch/amd64/vm.h>
#include <arch/amd64/idt.h>

void amd64_page_fault(size_t stack_frame, size_t fault_address)
{
size_t fault_addr;
size_t fault_code;
struct amd64_stack_frame *frame;

	frame = (struct amd64_stack_frame *)stack_frame;
	printk("amd64_page_fault() address=%p code=%i\n",fault_address,frame->error);
	printk("amd64_page_fault() offending code=%p\n",frame->rip);
	for(;;);

}